<template>
  <div class="row m-0 vh-100 justify-content-center align-items-center">
    <div class="col-auto p-5">
      <div class="card">
        <h1 class="card-header text-center">Heroes App</h1>
        <div class="card-body">
          <p>Estás a solo un paso de tu nueva contraseña, recupera tu contraseña ahora.</p>
          <p v-if="errorMessage" class="text-danger">{{errorMessage}}</p>
          <form @submit.prevent="procesar" autocomplete="off">
            <div class="mb-3">
              <div class="input-group">
                <input type="email" class="form-control" :class="{'is-valid': !$v.email.$invalid, 'is-invalid': $v.email.$invalid}" placeholder="Correo electrónico" v-model="$v.email.$model" @keypress="limpiarErrores('email')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-envelope"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.email.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.email.email">
                El campo debe ser una dirección de correo válida.
              </div>
              <div class="text-danger" v-for="(errorEmail, index) in errors.email" :key="index">
                {{ errorEmail }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="text" class="form-control" :class="{'is-valid': !$v.codigo.$invalid, 'is-invalid': $v.codigo.$invalid}" placeholder="Codigo" v-model="$v.codigo.$model" @keypress="limpiarErrores('codigo')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-barcode"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.codigo.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-for="(errorCodigo, index) in errors.codigo" :key="index">
                {{ errorCodigo }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="password" class="form-control" :class="{'is-valid': !$v.password.$invalid, 'is-invalid': $v.password.$invalid}" placeholder="Contraseña" v-model="$v.password.$model" @keypress="limpiarErrores('password')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-lock"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.password.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.password.minLength">
                Debe ser de al menos {{$v.password.$params.minLength.min}} caracteres
              </div>
              <div class="text-danger" v-if="!$v.password.maxLength">
                Debe ser menor de {{$v.password.$params.maxLength.max}} caracteres
              </div>
              <div class="text-danger" v-for="(errorPass, index) in errors.password" :key="index">
                {{ errorPass }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="password" class="form-control" :class="{'is-valid': !$v.passwordConfirm.$invalid, 'is-invalid': $v.passwordConfirm.$invalid}" placeholder="Repetir contraseña" v-model="$v.passwordConfirm.$model" @keypress="limpiarErrores('password_confirmation')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-lock"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.passwordConfirm.sameAs">
                Las contraseñas no coinciden
              </div>
              <div class="text-danger" v-for="(errorPassCon, index) in errors.password_confirmation" :key="index">
                {{ errorPassCon }}
              </div>
            </div>
            <button type="submit" :disabled="$v.$invalid || loading" class="btn btn-primary btn-block"><i v-if="loading" class="fas fa-spinner fa-pulse"></i> Cambiar contraseña</button>
          </form>

          <div class="mt-3 mb-1">
            <routerLink :to="{name: 'Login'}">Ya tengo una cuenta</routerLink>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { required, email, minLength, maxLength, sameAs } from 'vuelidate/lib/validators';

export default {
  data() {
    return {
      email: '',
      codigo: '',
      password: '',
      passwordConfirm: '',
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  validations: {
    email: {
      required,
      email
    },
    codigo: {
      required
    },
    password: {
      required,
      minLength: minLength(8),
      maxLength: maxLength(18)
    },
    passwordConfirm: {
      sameAs: sameAs('password')
    }
  },
  methods: {
    procesar () {
      this.loading = true
      let config = {
        headers: {
          'Accept': 'application/json'
        }
      }
      let body = {
        email: this.$v.email.$model,
        codigo: this.$v.codigo.$model,
        password: this.$v.password.$model,
        password_confirmation: this.$v.passwordConfirm.$model
      }
      this.axios.post('/auth/recovery', body, config)
        .then((res) => {
          this.loading = false
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
          this.$router.push({name: 'Login'})
        })
        .catch((e) => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    limpiarErrorMessage () {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores (name) {
      delete this.errors[name]
    }
  }
}
</script>
